#ifndef __PAGE_H__
#define __PAGE_H__

#include <generic/types.h>

#define PAGE_SHIFT 12                   /* Inspiration from linux */
#define PAGE (1 << PAGE_SHIFT)
#define PAGESIZE PAGE
#define PTESIZE 4
#define PAGE_ALIGN(x) ( x & ~(PAGE - 1) )

#define PGDIR_SHIFT 22
#define PGDIR (1 << 22)
#define PGDIR_ALIGN(x) ( x & ~(PGDIR - 1) )

#define PGDIR_OFFSET(va) ( PGDIR_ALIGN(va) >> PGDIR_SHIFT)
#define PGTABLE_OFFSET(va) (PAGE_ALIGN(va - PGDIR_ALIGN (va) ) >> PAGE_SHIFT)
#define PAGE_ALIGNED(va) ( !( va & (PAGE - 1) ) )

#define PG_PRESENT      1
#define PG_WRITE        2
#define PG_USER         4
/* #define PG_KERNEL    (~PG_USER) -- Awkward */
#define PG_ACCESSED     0x20
#define PG_DIRTY        0x40
#define PG_AVAIL0       0x200
#define PG_AVAIL1       0x400
#define PG_AVAIL2       0x800

#define flush_tlb()  asm ("pushl %eax \n movl %cr3, %eax \n movl %eax, %cr3 \n popl %eax \n")

typedef struct pagetableentry {
        ulong   pte;
} pte_t;
#endif
