/*
 *      Author: K.sarnath 26-Jan-2001
 */
#ifndef __PMEM_H__
#define __PMEM_H__

#include <generic/types.h>
#include <i386/page.h>
#include <config.h>
#include <mm/ptov.h>

enum page_status { ALLOCATED, FREE };
enum page_owner { SYSTEM , USER , PAGE_TABLE};

typedef struct page {
        uint status:1;
        uint owner:2;   // see enum page_owner. This field should hold the
                        // maximum ENUM value. Now it can hold a max val of 3.
        ulong mapcount; // This field tells how much mappings are there for an allocated physical addresses.
        union {
                struct page *next_free; // This PTR is valid only
                                        // if page is free.
                struct page *next_page_table;
                // All allocated page-tables are in a linked list.
        } link;
        void *mappings;
} pmem_t;

extern pmem_t *freememhead;
extern ulong pmem_alloc(int);
extern int pmem_free( ulong );
extern pmem_t *mem_table;
extern pmem_t *pagetable_head;
extern pmem_t *pagetable_tail;
#endif
