/*
 *      Author: K.sarnath 27-Jan-2001
 */
#ifndef __VM_H__
#define __VM_H__

#include <generic/types.h>
#include <i386/page.h>
#include <config.h>

enum seg_type { PANIC, MAP, KMEM , USER_TEXT, USER_DATA};
/*
 *  PANIC ->  If fault occurs in this segment, just panic. All kernel text and
 *            data come under this segment.
 *  MAP   -> If fault occurs in this segment, just allocate phys memory
 *           and set up a mapping, in case of a valid address. Used mostly
 *           in the early_stage. ( see the variable early_stage usage in page-
 *           fault handler. exp, kva handler , in kernel/kvm.c
 *  KMEM  -> Call the app. handler. Let him decide.
 */
typedef struct seg {
        unsigned long base;
        ulong limit;
        enum seg_type type;
        struct seg *next;
        int   (*pageFaultHandler)(ulong va);
}seg_t;

typedef struct as {
        struct seg *segments;
/*
 *      Virtual Address Segments. I think linux calls this
 *      data structure as "vm_area".
 */
        pte_t *pgdir;
/*      The page directory. */
} as_t;

extern as_t kas;
extern map_segment_handler( ulong );
extern int panic();
extern int panic_segment_handler(ulong);
extern void seg_init();
extern int kmemsegment_pagefault_handler(ulong);
extern as_t kas;
extern seg_t kmemseg;
extern seg_t statickernelseg;

#endif
