/*
 *      Author: K.Sarnath.
 *      14-Jan-2001.
 *      8259 is Initialized here. "register_idt_entry" is also here.
 *      Some more stuff left out.. (Selectively masking of interrupts etc...)
 */

#include <i386/idt.h>
#include <generic/types.h>
#include <config.h>

idt_t *IDT_BASE = (idt_t *) (KERNEL + IDTBASE);
idt_t *ptr;

#define MASTER_PORTA 0x20
#define MASTER_PORTB 0x21
#define SLAVE_PORTA  0xA0
#define SLAVE_PORTB  0xA1

void initialize_8259()
{
        asm ("cli");

        asm("movb $0x11, %al"); //To Master Port A
        asm("movw $0x20, %dx");
        asm ("outb (%dx)");
        asm ("movw $0xA0, %dx");
        asm("outb (%dx)");

        asm("movb $0x20 , %al");        //To Master Port B
        asm("movw $0x21 , %dx");
        asm("outb (%dx)");
        asm("movb $0x28 , %al");        //To Slave Port B
        asm("movw $0xA1 , %dx");
        asm("outb (%dx)");

        asm("movb $0x4, %al");          //To Master Port B
        asm("movw $0x21 , %dx");
        asm("outb (%dx)");
        asm("movb $0x2, %al");          // To Slave Port B
        asm("movw $0xA1 , %dx");
        asm("outb (%dx)");

        asm("movb $0x5 , %al");         // To Master Port B
        asm("movw $0x21, %dx");
        asm("outb (%dx)");
        asm("movb $0x1 , %al");         // To Slave Port B
        asm ("movw $0xA1, %dx");
        asm("outb (%dx)");

        asm ("cli");
        return;
}

void
register_idt_entry(uchar num, sint selector, ulong offset ,uchar dpl, uchar present, enum idt_entry type)
{

#ifdef __DEBUG__
        printk ("\n\t register_idt_entry num=%x, selector=%x, offset=%x,dpl=%x,present=%x,type=%x", num,selector,offset,dpl,present,type);
#endif
        ptr = IDT_BASE + num;
        ptr -> selector = selector;
        ptr -> loffset = (short int) (offset & 0xffff);
        ptr -> uoffset = (short int) ((offset & 0xffff0000) >> 16) ;
        ptr -> present = present;
        ptr -> constant = type;
        ptr -> dpl = dpl;
        ptr->unused = 0;
        return;
}
