#
# Kernel Sub-System Makefile.
#

KERNEL_OBJ_TARGETS=$(foreach FILE,$(wildcard $(KERNEL_DIR)/*.[cs]),$(addsuffix .o,$(basename $(FILE))))
CFLAGS=-I ${ROOT_DIR}/include -c -fno-builtin -DMALIGN_DEBUG

#
# The Main Rule for this directory.
#
$(KERNEL_OBJECT):   $(KERNEL_OBJ_TARGETS)
	${LD} -r -o $(KERNEL_OBJECT) ${KERNEL_OBJ_TARGETS}

#
# The "-r" option means "do a relocatable Partial linking". We dont link fully.
# Otherwise these code and data wont get relocated properly during the
# final linking.
#

#
# The cleaning rule.
#
$(KERNEL_DIR)/clean:
	rm  -f $(KERNEL_OBJ_TARGETS) $(KERNEL_OBJECT) $(INIT_OBJECT)
