/*
 *      Author:         K.Sarnath. 4-Jan-2001
 *      Last updated:   14-Jan-2001
 */
#define BYTES_PER_ROW   160
#define MAX_ROWS        25
#define uint    unsigned int
#define ulong   unsigned long

        /* Data declaration */
char *VideoBase;
char *WritePtr;
char *ScreenEnd;
char Attribute;
void *arg;

        /* Fn declaration */
void scroll();
int TermWriteChar(char);
char ConvertToAscii (char) ;
int TermWrite8Bit (char );
int TermWrite16Bit(short int );
extern int TermWriteString();

void cls()
{
        char *clear;
                /* Clear Screen */
        for (clear = VideoBase; clear < ScreenEnd; clear += 2) {
                *clear = ' ';
                *(clear + 1) = Attribute;
        }
}

int PrintkInit()
{

        WritePtr = VideoBase = (char *)0xC00B8000;
        ScreenEnd = VideoBase + BYTES_PER_ROW*MAX_ROWS;
        Attribute = 0x07;       // Normal attribute
        cls();
        return 0;
}


/*
 *      This Function handles Formatted output onto the screen.
 *      It takes care of %s, %x options also.
 *              %x -> Prints in HexaDecimal. Unsigned 32-bit num
 *              %s -> Prints a String on to screen.
 */

int printk(char *String)
{
        int i, Index ,Deficit, ArgNum = 0 , FP;
        char next;
        unsigned int number;

        Index = 0;
        while(String[Index]) {

                switch ( String[Index] )
                {
                     case '\n':
                        Deficit = BYTES_PER_ROW - (unsigned int)(WritePtr-VideoBase) % BYTES_PER_ROW;
                        WritePtr += Deficit;
                        if (WritePtr >= ScreenEnd)  {
                                scroll();
                                WritePtr = ScreenEnd - BYTES_PER_ROW;
                        }
                        break;

                     case '\t':
                        for (i=0;i<5;i++) TermWriteChar(' ');
                        break;

                     case '%':
                        next = String[Index+1];
                        if ( next == 'x' || next == 'X' ) {
                                Index ++;
                                ArgNum++;
                                asm ("movl %ebp , arg");
                                arg = (void *) ((char *)arg + 8 + ArgNum*4);
                                number = *(uint *) arg;
                                TermWrite32Bit( number );
                                break;
                        }

                        if (next =='s' || next == 'S') {
                                ArgNum ++;
                                Index ++;
                                asm ("movl %ebp , arg");
                                arg = (void *) ((char *)arg + 8 + ArgNum*4);
                                arg = (void *) *(uint *)arg;
                                PrintString(arg);
                                break;
                        }
                        TermWriteChar(String[Index]);
                        break;

                default:
                        TermWriteChar(String[Index]);
                }
                Index ++;
        }
        return 0;
}

/* This Function is used to write a String onto the screen,
   without interpretting % signs. This is called from printk
   whenever it sees %s on the input.
*/

int PrintString (char *String)
{
        int i, Index ,Deficit, ArgNum = 1 , FP;

        Index = 0;
        while(String[Index]) {

                switch ( String[Index] )
                {
                     case '\n':
                        Deficit = BYTES_PER_ROW - (unsigned int)(WritePtr-VideoBase) % BYTES_PER_ROW;
                        WritePtr += Deficit;
                        if (WritePtr > ScreenEnd) WritePtr = ScreenEnd;
                        break;

                     case '\t':
                        for (i=0;i<5;i++) TermWriteChar(' ');
                        break;

                     default:
                        TermWriteChar(String[Index]);
                }
                Index ++;
        }
        return 0;
}

int TermWrite32Bit (long i)
{
        TermWrite16Bit ( ( i & 0xffff0000 ) >> 16 );
        TermWrite16Bit ( i & 0x0000ffff);
        return 0;
}


int TermWrite16Bit(short int i)
{
        TermWrite8Bit ((i & 0xff00) >> 8);
        TermWrite8Bit (i & 0x00ff);
        return 0;
}

int TermWrite8Bit (char ch)
{
        char temp;

        temp = ConvertToAscii( (ch & 0xf0) >> 4);
        TermWriteChar(temp);
        temp = ConvertToAscii(ch & 0x0f);
        TermWriteChar(temp);
        return 0;
}


int TermWriteChar(char ch)
{

        if (WritePtr == ScreenEnd) {
                scroll();
                WritePtr -= BYTES_PER_ROW;
        }
        *WritePtr++ = ch ;
        *WritePtr++ = Attribute;
}

void scroll()
{
        char *SrcPtr, *DestPtr ;

        DestPtr = VideoBase;
        SrcPtr = VideoBase + BYTES_PER_ROW;
        do {
                *DestPtr = *SrcPtr;
                DestPtr++;
                SrcPtr++;
        }
        while (SrcPtr < ScreenEnd);

        while (DestPtr < ScreenEnd) {
                *DestPtr++ = ' ';
                *DestPtr++ = Attribute;
        }
        return;
}



char ConvertToAscii (char ch)
{
        if (ch <= 0x09)
                ch += 0x30;
        else
                ch += 0x37;
        return ch;
}
